                                                                                     !/*
! * SocketTools Library Edition
! * Version 3.0
! *
! * Copyright 1995-1999, Catalyst Development Corporation
! * All rights reserved
! *
! * This module contains the confidential and proprietary information
! * of Catalyst Development Corporation and may not be redistributed.
! *
! * This product is licensed to you pursuant to the terms of the
! * Catalyst license agreement included with the original software,
! * and is protected by copyright law and international treaties.
! * Unauthorized reproduction or distribution may result in severe
! * criminal penalties.
! */

!***************************************************************************
! Notes for the Clarion Conversion
!
! This document is being distributed with the permission of
! Catalyst Development Corporation.
!
! The C prototypes have been left in place for reference in debugging
! and to facilitate the learning process for those Clarion programmers
! who are unfamiliar with C.
!
! Each block of prototypes begins with the commented C version, followed
! by the Clarion prototypes
!
! The proverbial disclaimer:
! This C to CW conversion is being offered as service to the Clarion
! developer community. As such, none of the contributors make any assurance
! that this code will work for you. There may be errors and omissions. If
! you find an error or omission, you are encouraged to submitt your *tested*
! fix for inclusion in a future release.
!
! Initial conversion to Clarion by: Mark Geisinger
! POP3 courtesy of Greg Palmer by way of Jeff Slarve
! Comments or corrections may be sent to: critters@bugsbugme.com
! Initial public release:   09/20/1998
! Updated:                  09/22/1998
!    Added the cstools_readme.txt file. See that file for release notes and
!    usage information.
!***************************************************************************

!#ifndef _CSTOOLS_CSERROR_H
!#define _CSTOOLS_CSERROR_H

!#ifdef __cplusplus
!extern "C" {
!#endif

! This section contains the error codes for the SocketTools
! audio library.

!#define AUDIO_ERROR -1

!#define _AUDIO_BASE_ERROR           25100
!#define ERROR_AUDIO_NONE            0
!#define ERROR_AUDIO_LICENSE         (_AUDIO_BASE_ERROR+1)
!#define ERROR_AUDIO_FILE            (_AUDIO_BASE_ERROR+2)
!#define ERROR_AUDIO_INPUT           (_AUDIO_BASE_ERROR+3)
!#define ERROR_AUDIO_OUTPUT          (_AUDIO_BASE_ERROR+4)
!#define ERROR_AUDIO_MEMORY          (_AUDIO_BASE_ERROR+5)
!#define ERROR_AUDIO_PARAMETER       (_AUDIO_BASE_ERROR+6)
!#define ERROR_AUDIO_NOSUPPORT       (_AUDIO_BASE_ERROR+7)
!#define ERROR_AUDIO_READONLY        (_AUDIO_BASE_ERROR+8)
!#define ERROR_AUDIO_WRITEONLY       (_AUDIO_BASE_ERROR+9)
!#define ERROR_AUDIO_STREAM          (_AUDIO_BASE_ERROR+10)
!#define ERROR_AUDIO_HEADER          (_AUDIO_BASE_ERROR+11)
!#define ERROR_AUDIO_FORMAT          (_AUDIO_BASE_ERROR+12)
!#define ERROR_AUDIO_SAMPLE          (_AUDIO_BASE_ERROR+13)
!#define ERROR_AUDIO_EOF             (_AUDIO_BASE_ERROR+14)
!#define ERROR_AUDIO_DEVICE          (_AUDIO_BASE_ERROR+15)

AUDIO_ERROR equate(-1)

_AUDIO_BASE_ERROR           equate(25100)
ERROR_AUDIO_NONE            equate(0)
ERROR_AUDIO_LICENSE         equate(_AUDIO_BASE_ERROR+1)
ERROR_AUDIO_FILE            equate(_AUDIO_BASE_ERROR+2)
ERROR_AUDIO_INPUT           equate(_AUDIO_BASE_ERROR+3)
ERROR_AUDIO_OUTPUT          equate(_AUDIO_BASE_ERROR+4)
ERROR_AUDIO_MEMORY          equate(_AUDIO_BASE_ERROR+5)
ERROR_AUDIO_PARAMETER       equate(_AUDIO_BASE_ERROR+6)
ERROR_AUDIO_NOSUPPORT       equate(_AUDIO_BASE_ERROR+7)
ERROR_AUDIO_READONLY        equate(_AUDIO_BASE_ERROR+8)
ERROR_AUDIO_WRITEONLY       equate(_AUDIO_BASE_ERROR+9)
ERROR_AUDIO_STREAM          equate(_AUDIO_BASE_ERROR+10)
ERROR_AUDIO_HEADER          equate(_AUDIO_BASE_ERROR+11)
ERROR_AUDIO_FORMAT          equate(_AUDIO_BASE_ERROR+12)
ERROR_AUDIO_SAMPLE          equate(_AUDIO_BASE_ERROR+13)
ERROR_AUDIO_EOF             equate(_AUDIO_BASE_ERROR+14)
ERROR_AUDIO_DEVICE          equate(_AUDIO_BASE_ERROR+15)

!/*************************************************************************
! *
! * This section contains the error codes for the SocketTools
! * Domain Name Service (DNS) client library.
! *
! *************************************************************************/

!#define DNS_ERROR -1

!#define _DNS_BASE_ERROR             25300
!#define ERROR_DNS_NONE              0
!#define ERROR_DNS_NETWORK           (_DNS_BASE_ERROR+1)
!#define ERROR_DNS_LICENSE           (_DNS_BASE_ERROR+2)
!#define ERROR_DNS_NOHANDLES         (_DNS_BASE_ERROR+3)
!#define ERROR_DNS_NOTOWNER          (_DNS_BASE_ERROR+4)
!#define ERROR_DNS_HANDLE            (_DNS_BASE_ERROR+5)
!#define ERROR_DNS_MEMORY            (_DNS_BASE_ERROR+6)
!#define ERROR_DNS_PARAMETER         (_DNS_BASE_ERROR+7)
!#define ERROR_DNS_SOCKET            (_DNS_BASE_ERROR+8)
!#define ERROR_DNS_HOSTNAME          (_DNS_BASE_ERROR+9)
!#define ERROR_DNS_HOSTADDRESS       (_DNS_BASE_ERROR+10)
!#define ERROR_DNS_HOSTNOTFOUND      (_DNS_BASE_ERROR+11)
!#define ERROR_DNS_HOSTINFO          (_DNS_BASE_ERROR+12)
!#define ERROR_DNS_PROTOCOL          (_DNS_BASE_ERROR+13)
!#define ERROR_DNS_RECORDTYPE        (_DNS_BASE_ERROR+14)
!#define ERROR_DNS_RECORDNAME        (_DNS_BASE_ERROR+15)
!#define ERROR_DNS_RECORDDATA        (_DNS_BASE_ERROR+16)
!#define ERROR_DNS_SERVERINDEX       (_DNS_BASE_ERROR+17)
!#define ERROR_DNS_SERVERADDR        (_DNS_BASE_ERROR+18)
!#define ERROR_DNS_SERVERPORT        (_DNS_BASE_ERROR+19)
!#define ERROR_DNS_SERVERFAIL        (_DNS_BASE_ERROR+20)
!#define ERROR_DNS_NORESPONSE        (_DNS_BASE_ERROR+21)
!#define ERROR_DNS_BADRESPONSE       (_DNS_BASE_ERROR+22)
!#define ERROR_DNS_REFUSED           (_DNS_BASE_ERROR+23)
!#define ERROR_DNS_TIMEOUT           (_DNS_BASE_ERROR+24)
!#define ERROR_DNS_CANCELED          (_DNS_BASE_ERROR+25)

DNS_ERROR equate(-1)

_DNS_BASE_ERROR             equate(25300)
ERROR_DNS_NONE              equate(0)
ERROR_DNS_NETWORK           equate(_DNS_BASE_ERROR+1)
ERROR_DNS_LICENSE           equate(_DNS_BASE_ERROR+2)
ERROR_DNS_NOHANDLES         equate(_DNS_BASE_ERROR+3)
ERROR_DNS_NOTOWNER          equate(_DNS_BASE_ERROR+4)
ERROR_DNS_HANDLE            equate(_DNS_BASE_ERROR+5)
ERROR_DNS_MEMORY            equate(_DNS_BASE_ERROR+6)
ERROR_DNS_PARAMETER         equate(_DNS_BASE_ERROR+7)
ERROR_DNS_SOCKET            equate(_DNS_BASE_ERROR+8)
ERROR_DNS_HOSTNAME          equate(_DNS_BASE_ERROR+9)
ERROR_DNS_HOSTADDRESS       equate(_DNS_BASE_ERROR+10)
ERROR_DNS_HOSTNOTFOUND      equate(_DNS_BASE_ERROR+11)
ERROR_DNS_HOSTINFO          equate(_DNS_BASE_ERROR+12)
ERROR_DNS_PROTOCOL          equate(_DNS_BASE_ERROR+13)
ERROR_DNS_RECORDTYPE        equate(_DNS_BASE_ERROR+14)
ERROR_DNS_RECORDNAME        equate(_DNS_BASE_ERROR+15)
ERROR_DNS_RECORDDATA        equate(_DNS_BASE_ERROR+16)
ERROR_DNS_SERVERINDEX       equate(_DNS_BASE_ERROR+17)
ERROR_DNS_SERVERADDR        equate(_DNS_BASE_ERROR+18)
ERROR_DNS_SERVERPORT        equate(_DNS_BASE_ERROR+19)
ERROR_DNS_SERVERFAIL        equate(_DNS_BASE_ERROR+20)
ERROR_DNS_NORESPONSE        equate(_DNS_BASE_ERROR+21)
ERROR_DNS_BADRESPONSE       equate(_DNS_BASE_ERROR+22)
ERROR_DNS_REFUSED           equate(_DNS_BASE_ERROR+23)
ERROR_DNS_TIMEOUT           equate(_DNS_BASE_ERROR+24)
ERROR_DNS_CANCELED          equate(_DNS_BASE_ERROR+25)

!/*************************************************************************
! *
! * This section contains the error codes for the SocketTools
! * Finger client library.
! *
! *************************************************************************/

!#define FINGER_ERROR -1

!#define _FINGER_BASE_ERROR          25500
!#define ERROR_FINGER_NONE           0
!#define ERROR_FINGER_NETWORK        (_FINGER_BASE_ERROR+1)
!#define ERROR_FINGER_LICENSE        (_FINGER_BASE_ERROR+2)
!#define ERROR_FINGER_NOHANDLES      (_FINGER_BASE_ERROR+3)
!#define ERROR_FINGER_NOTOWNER       (_FINGER_BASE_ERROR+4)
!#define ERROR_FINGER_HANDLE         (_FINGER_BASE_ERROR+5)
!#define ERROR_FINGER_MEMORY         (_FINGER_BASE_ERROR+6)
!#define ERROR_FINGER_PARAMETER      (_FINGER_BASE_ERROR+7)
!#define ERROR_FINGER_HOSTNAME       (_FINGER_BASE_ERROR+8)
!#define ERROR_FINGER_SOCKET         (_FINGER_BASE_ERROR+9)
!#define ERROR_FINGER_CONNECT        (_FINGER_BASE_ERROR+10)
!#define ERROR_FINGER_TIMEOUT        (_FINGER_BASE_ERROR+11)
!#define ERROR_FINGER_READ           (_FINGER_BASE_ERROR+12)
!#define ERROR_FINGER_WRITE          (_FINGER_BASE_ERROR+13)
!#define ERROR_FINGER_RETRY          (_FINGER_BASE_ERROR+14)
!#define ERROR_FINGER_OVERFLOW       (_FINGER_BASE_ERROR+15)
!#define ERROR_FINGER_BLOCKED        (_FINGER_BASE_ERROR+16)
!#define ERROR_FINGER_CANCELED       (_FINGER_BASE_ERROR+17)

! This section contains the error codes for the SocketTools
! File Transfer Protocol (FTP) client library.

FTP_ERROR   equate(-1)

_FTP_BASE_ERROR             equate(25700)
ERROR_FTP_NONE              equate(0)
ERROR_FTP_NETWORK           equate(_FTP_BASE_ERROR+1)
ERROR_FTP_LICENSE           equate(_FTP_BASE_ERROR+2)
ERROR_FTP_NOHANDLES         equate(_FTP_BASE_ERROR+3)
ERROR_FTP_NOTOWNER          equate(_FTP_BASE_ERROR+4)
ERROR_FTP_HANDLE            equate(_FTP_BASE_ERROR+5)
ERROR_FTP_MEMORY            equate(_FTP_BASE_ERROR+6)
ERROR_FTP_PARAMETER         equate(_FTP_BASE_ERROR+7)
ERROR_FTP_HOSTNAME          equate(_FTP_BASE_ERROR+8)
ERROR_FTP_SOCKET            equate(_FTP_BASE_ERROR+9)
ERROR_FTP_ACCEPT            equate(_FTP_BASE_ERROR+10)
ERROR_FTP_CONNECT           equate(_FTP_BASE_ERROR+11)
ERROR_FTP_PEERNAME          equate(_FTP_BASE_ERROR+12)
ERROR_FTP_BIND              equate(_FTP_BASE_ERROR+13)
ERROR_FTP_LISTEN            equate(_FTP_BASE_ERROR+14)
ERROR_FTP_READ              equate(_FTP_BASE_ERROR+15)
ERROR_FTP_WRITE             equate(_FTP_BASE_ERROR+16)
ERROR_FTP_RETRY             equate(_FTP_BASE_ERROR+17)
ERROR_FTP_EOF               equate(_FTP_BASE_ERROR+18)
ERROR_FTP_OVERFLOW          equate(_FTP_BASE_ERROR+19)
ERROR_FTP_BLOCKED           equate(_FTP_BASE_ERROR+20)
ERROR_FTP_NOTBUSY           equate(_FTP_BASE_ERROR+21)
ERROR_FTP_TIMEOUT           equate(_FTP_BASE_ERROR+22)
ERROR_FTP_RESYNC            equate(_FTP_BASE_ERROR+23)
ERROR_FTP_CLOSED            equate(_FTP_BASE_ERROR+24)
ERROR_FTP_NOTREADY          equate(_FTP_BASE_ERROR+25)
ERROR_FTP_NOTAVAIL          equate(_FTP_BASE_ERROR+26)
ERROR_FTP_SERVICE           equate(_FTP_BASE_ERROR+27)
ERROR_FTP_DATAPORT          equate(_FTP_BASE_ERROR+28)
ERROR_FTP_DATAOPEN          equate(_FTP_BASE_ERROR+29)
ERROR_FTP_DATACLOSED        equate(_FTP_BASE_ERROR+30)
ERROR_FTP_CANCELED          equate(_FTP_BASE_ERROR+31)
ERROR_FTP_READONLY          equate(_FTP_BASE_ERROR+32)
ERROR_FTP_WRITEONLY         equate(_FTP_BASE_ERROR+33)
ERROR_FTP_FILETYPE          equate(_FTP_BASE_ERROR+34)
ERROR_FTP_PASSIVE           equate(_FTP_BASE_ERROR+35)
ERROR_FTP_ADDRESS           equate(_FTP_BASE_ERROR+36)
ERROR_FTP_CREATEFILE        equate(_FTP_BASE_ERROR+37)
ERROR_FTP_OPENFILE          equate(_FTP_BASE_ERROR+38)
ERROR_FTP_READFILE          equate(_FTP_BASE_ERROR+39)
ERROR_FTP_WRITEFILE         equate(_FTP_BASE_ERROR+40)
ERROR_FTP_LOGIN             equate(_FTP_BASE_ERROR+41)
ERROR_FTP_OPENFAIL          equate(_FTP_BASE_ERROR+42)
ERROR_FTP_FILEBUSY          equate(_FTP_BASE_ERROR+43)
ERROR_FTP_NOSPACE           equate(_FTP_BASE_ERROR+44)
ERROR_FTP_COMMAND           equate(_FTP_BASE_ERROR+45)
ERROR_FTP_ARGUMENT          equate(_FTP_BASE_ERROR+46)
ERROR_FTP_CMDIMP            equate(_FTP_BASE_ERROR+47)
ERROR_FTP_CMDSEQ            equate(_FTP_BASE_ERROR+48)
ERROR_FTP_NOLOGIN           equate(_FTP_BASE_ERROR+49)
ERROR_FTP_NOACCOUNT         equate(_FTP_BASE_ERROR+50)
ERROR_FTP_ACCESS            equate(_FTP_BASE_ERROR+51)
ERROR_FTP_FILEALLOC         equate(_FTP_BASE_ERROR+52)
ERROR_FTP_FILENAME          equate(_FTP_BASE_ERROR+53)
ERROR_FTP_UNEXPECTED        equate(_FTP_BASE_ERROR+54)
ERROR_FTP_RESTART           equate(_FTP_BASE_ERROR+55)

!/*************************************************************************
! *
! * This section contains the error codes for the SocketTools
! * Gopher client library.
! *
! *************************************************************************/

!#define GOPHER_ERROR -1

!#define _GOPHER_BASE_ERROR          25900
!#define ERROR_GOPHER_NONE           0
!#define ERROR_GOPHER_NETWORK        (_GOPHER_BASE_ERROR+1)
!#define ERROR_GOPHER_LICENSE        (_GOPHER_BASE_ERROR+2)
!#define ERROR_GOPHER_NOHANDLES      (_GOPHER_BASE_ERROR+3)
!#define ERROR_GOPHER_NOTOWNER       (_GOPHER_BASE_ERROR+4)
!#define ERROR_GOPHER_HANDLE         (_GOPHER_BASE_ERROR+5)
!#define ERROR_GOPHER_MEMORY         (_GOPHER_BASE_ERROR+6)
!#define ERROR_GOPHER_PARAMETER      (_GOPHER_BASE_ERROR+7)
!#define ERROR_GOPHER_HOSTNAME       (_GOPHER_BASE_ERROR+8)
!#define ERROR_GOPHER_SOCKET         (_GOPHER_BASE_ERROR+9)
!#define ERROR_GOPHER_CONNECT        (_GOPHER_BASE_ERROR+10)
!#define ERROR_GOPHER_TIMEOUT        (_GOPHER_BASE_ERROR+11)
!#define ERROR_GOPHER_SERVER         (_GOPHER_BASE_ERROR+12)
!#define ERROR_GOPHER_READ           (_GOPHER_BASE_ERROR+13)
!#define ERROR_GOPHER_WRITE          (_GOPHER_BASE_ERROR+14)
!#define ERROR_GOPHER_RETRY          (_GOPHER_BASE_ERROR+15)
!#define ERROR_GOPHER_OVERFLOW       (_GOPHER_BASE_ERROR+16)
!#define ERROR_GOPHER_CLOSED         (_GOPHER_BASE_ERROR+17)
!#define ERROR_GOPHER_BLOCKED        (_GOPHER_BASE_ERROR+18)
!#define ERROR_GOPHER_CANCELED       (_GOPHER_BASE_ERROR+19)
!#define ERROR_GOPHER_BADITEM        (_GOPHER_BASE_ERROR+20)

GOPHER_ERROR equate(-1)

_GOPHER_BASE_ERROR          equate(25900)
ERROR_GOPHER_NONE           equate(0)
ERROR_GOPHER_NETWORK        equate(_GOPHER_BASE_ERROR+1)
ERROR_GOPHER_LICENSE        equate(_GOPHER_BASE_ERROR+2)
ERROR_GOPHER_NOHANDLES      equate(_GOPHER_BASE_ERROR+3)
ERROR_GOPHER_NOTOWNER       equate(_GOPHER_BASE_ERROR+4)
ERROR_GOPHER_HANDLE         equate(_GOPHER_BASE_ERROR+5)
ERROR_GOPHER_MEMORY         equate(_GOPHER_BASE_ERROR+6)
ERROR_GOPHER_PARAMETER      equate(_GOPHER_BASE_ERROR+7)
ERROR_GOPHER_HOSTNAME       equate(_GOPHER_BASE_ERROR+8)
ERROR_GOPHER_SOCKET         equate(_GOPHER_BASE_ERROR+9)
ERROR_GOPHER_CONNECT        equate(_GOPHER_BASE_ERROR+10)
ERROR_GOPHER_TIMEOUT        equate(_GOPHER_BASE_ERROR+11)
ERROR_GOPHER_SERVER         equate(_GOPHER_BASE_ERROR+12)
ERROR_GOPHER_READ           equate(_GOPHER_BASE_ERROR+13)
ERROR_GOPHER_WRITE          equate(_GOPHER_BASE_ERROR+14)
ERROR_GOPHER_RETRY          equate(_GOPHER_BASE_ERROR+15)
ERROR_GOPHER_OVERFLOW       equate(_GOPHER_BASE_ERROR+16)
ERROR_GOPHER_CLOSED         equate(_GOPHER_BASE_ERROR+17)
ERROR_GOPHER_BLOCKED        equate(_GOPHER_BASE_ERROR+18)
ERROR_GOPHER_CANCELED       equate(_GOPHER_BASE_ERROR+19)
ERROR_GOPHER_BADITEM        equate(_GOPHER_BASE_ERROR+20)
!/*************************************************************************
! *
! * This section contains the error codes for the SocketTools
! * Hypertext Transfer Protocol (HTTP) client library.
! *
! *************************************************************************/

! #define HTTP_ERROR -1

! #define _HTTP_BASE_ERROR              26000
! #define ERROR_HTTP_NONE               0
! #define ERROR_HTTP_NETWORK            (_HTTP_BASE_ERROR+1)
! #define ERROR_HTTP_LICENSE            (_HTTP_BASE_ERROR+2)
! #define ERROR_HTTP_NOHANDLES          (_HTTP_BASE_ERROR+3)
! #define ERROR_HTTP_NOTOWNER           (_HTTP_BASE_ERROR+4)
! #define ERROR_HTTP_HANDLE             (_HTTP_BASE_ERROR+5)
! #define ERROR_HTTP_MEMORY             (_HTTP_BASE_ERROR+6)
! #define ERROR_HTTP_PARAMETER          (_HTTP_BASE_ERROR+7)
! #define ERROR_HTTP_HOSTNAME           (_HTTP_BASE_ERROR+8)
! #define ERROR_HTTP_SOCKET             (_HTTP_BASE_ERROR+9)
! #define ERROR_HTTP_CONNECT            (_HTTP_BASE_ERROR+10)
! #define ERROR_HTTP_TIMEOUT            (_HTTP_BASE_ERROR+11)
! #define ERROR_HTTP_READ               (_HTTP_BASE_ERROR+12)
! #define ERROR_HTTP_WRITE              (_HTTP_BASE_ERROR+13)
! #define ERROR_HTTP_RETRY              (_HTTP_BASE_ERROR+14)
! #define ERROR_HTTP_OVERFLOW           (_HTTP_BASE_ERROR+15)
! #define ERROR_HTTP_CLOSED             (_HTTP_BASE_ERROR+16)
! #define ERROR_HTTP_BLOCKED            (_HTTP_BASE_ERROR+17)
! #define ERROR_HTTP_CANCELED           (_HTTP_BASE_ERROR+18)
! #define ERROR_HTTP_PROTOCOL           (_HTTP_BASE_ERROR+19)
! #define ERROR_HTTP_COMMAND            (_HTTP_BASE_ERROR+20)
! #define ERROR_HTTP_QUERY              (_HTTP_BASE_ERROR+21)
! #define ERROR_HTTP_TRANSACTION        (_HTTP_BASE_ERROR+22)
! #define ERROR_HTTP_RESPONSE           (_HTTP_BASE_ERROR+23)
! #define ERROR_HTTP_VERSION            (_HTTP_BASE_ERROR+24)
! #define ERROR_HTTP_FILENAME           (_HTTP_BASE_ERROR+25)
! #define ERROR_HTTP_FILETYPE           (_HTTP_BASE_ERROR+26)
! #define ERROR_HTTP_FILELENGTH         (_HTTP_BASE_ERROR+27)
! #define ERROR_HTTP_CLIPBOARD          (_HTTP_BASE_ERROR+28)
! #define ERROR_HTTP_AUTHTYPE           (_HTTP_BASE_ERROR+29)
! #define ERROR_HTTP_USERNAME           (_HTTP_BASE_ERROR+30)
! #define ERROR_HTTP_PASSWORD           (_HTTP_BASE_ERROR+31)
! #define ERROR_HTTP_MOVED              (_HTTP_BASE_ERROR+32)
! #define ERROR_HTTP_NOTMODIFIED        (_HTTP_BASE_ERROR+33)
! #define ERROR_HTTP_REQUEST            (_HTTP_BASE_ERROR+34)
! #define ERROR_HTTP_UNAUTHORIZED       (_HTTP_BASE_ERROR+35)
! #define ERROR_HTTP_PAYMENT            (_HTTP_BASE_ERROR+36)
! #define ERROR_HTTP_FORBIDDEN          (_HTTP_BASE_ERROR+37)
! #define ERROR_HTTP_NOTFOUND           (_HTTP_BASE_ERROR+38)
! #define ERROR_HTTP_METHOD             (_HTTP_BASE_ERROR+39)
! #define ERROR_HTTP_NOTACCEPTED        (_HTTP_BASE_ERROR+40)
! #define ERROR_HTTP_PROXYAUTH          (_HTTP_BASE_ERROR+41)
! #define ERROR_HTTP_REMOVED            (_HTTP_BASE_ERROR+42)
! #define ERROR_HTTP_SERVER             (_HTTP_BASE_ERROR+43)
! #define ERROR_HTTP_GATEWAY            (_HTTP_BASE_ERROR+44)
! #define ERROR_HTTP_UNAVAILABLE        (_HTTP_BASE_ERROR+45)
! #define ERROR_HTTP_UNEXPECTED         (_HTTP_BASE_ERROR+46)

HTTP_ERROR                              EQUATE(-1)

_HTTP_BASE_ERROR                        EQUATE(26000)
ERROR_HTTP_NONE                         EQUATE(0)
ERROR_HTTP_NETWORK                      EQUATE(_HTTP_BASE_ERROR+1)
ERROR_HTTP_LICENSE                      EQUATE(_HTTP_BASE_ERROR+2)
ERROR_HTTP_NOHANDLES                    EQUATE(_HTTP_BASE_ERROR+3)
ERROR_HTTP_NOTOWNER                     EQUATE(_HTTP_BASE_ERROR+4)
ERROR_HTTP_HANDLE                       EQUATE(_HTTP_BASE_ERROR+5)
ERROR_HTTP_MEMORY                       EQUATE(_HTTP_BASE_ERROR+6)
ERROR_HTTP_PARAMETER                    EQUATE(_HTTP_BASE_ERROR+7)
ERROR_HTTP_HOSTNAME                     EQUATE(_HTTP_BASE_ERROR+8)
ERROR_HTTP_SOCKET                       EQUATE(_HTTP_BASE_ERROR+9)
ERROR_HTTP_CONNECT                      EQUATE(_HTTP_BASE_ERROR+10)
ERROR_HTTP_TIMEOUT                      EQUATE(_HTTP_BASE_ERROR+11)
ERROR_HTTP_READ                         EQUATE(_HTTP_BASE_ERROR+12)
ERROR_HTTP_WRITE                        EQUATE(_HTTP_BASE_ERROR+13)
ERROR_HTTP_RETRY                        EQUATE(_HTTP_BASE_ERROR+14)
ERROR_HTTP_OVERFLOW                     EQUATE(_HTTP_BASE_ERROR+15)
ERROR_HTTP_CLOSED                       EQUATE(_HTTP_BASE_ERROR+16)
ERROR_HTTP_BLOCKED                      EQUATE(_HTTP_BASE_ERROR+17)
ERROR_HTTP_CANCELED                     EQUATE(_HTTP_BASE_ERROR+18)
ERROR_HTTP_PROTOCOL                     EQUATE(_HTTP_BASE_ERROR+19)
ERROR_HTTP_COMMAND                      EQUATE(_HTTP_BASE_ERROR+20)
ERROR_HTTP_QUERY                        EQUATE(_HTTP_BASE_ERROR+21)
ERROR_HTTP_TRANSACTION                  EQUATE(_HTTP_BASE_ERROR+22)
ERROR_HTTP_RESPONSE                     EQUATE(_HTTP_BASE_ERROR+23)
ERROR_HTTP_VERSION                      EQUATE(_HTTP_BASE_ERROR+24)
ERROR_HTTP_FILENAME                     EQUATE(_HTTP_BASE_ERROR+25)
ERROR_HTTP_FILETYPE                     EQUATE(_HTTP_BASE_ERROR+26)
ERROR_HTTP_FILELENGTH                   EQUATE(_HTTP_BASE_ERROR+27)
ERROR_HTTP_CLIPBOARD                    EQUATE(_HTTP_BASE_ERROR+28)
ERROR_HTTP_AUTHTYPE                     EQUATE(_HTTP_BASE_ERROR+29)
ERROR_HTTP_USERNAME                     EQUATE(_HTTP_BASE_ERROR+30)
ERROR_HTTP_PASSWORD                     EQUATE(_HTTP_BASE_ERROR+31)
ERROR_HTTP_MOVED                        EQUATE(_HTTP_BASE_ERROR+32)
ERROR_HTTP_NOTMODIFIED                  EQUATE(_HTTP_BASE_ERROR+33)
ERROR_HTTP_REQUEST                      EQUATE(_HTTP_BASE_ERROR+34)
ERROR_HTTP_UNAUTHORIZED                 EQUATE(_HTTP_BASE_ERROR+35)
ERROR_HTTP_PAYMENT                      EQUATE(_HTTP_BASE_ERROR+36)
ERROR_HTTP_FORBIDDEN                    EQUATE(_HTTP_BASE_ERROR+37)
ERROR_HTTP_NOTFOUND                     EQUATE(_HTTP_BASE_ERROR+38)
ERROR_HTTP_METHOD                       EQUATE(_HTTP_BASE_ERROR+39)
ERROR_HTTP_NOTACCEPTED                  EQUATE(_HTTP_BASE_ERROR+40)
ERROR_HTTP_PROXYAUTH                    EQUATE(_HTTP_BASE_ERROR+41)
ERROR_HTTP_REMOVED                      EQUATE(_HTTP_BASE_ERROR+42)
ERROR_HTTP_SERVER                       EQUATE(_HTTP_BASE_ERROR+43)
ERROR_HTTP_GATEWAY                      EQUATE(_HTTP_BASE_ERROR+44)
ERROR_HTTP_UNAVAILABLE                  EQUATE(_HTTP_BASE_ERROR+45)
ERROR_HTTP_UNEXPECTED                   EQUATE(_HTTP_BASE_ERROR+46)

!/*************************************************************************
! *
! * This section contains the error codes for the SocketTools
! * Internet Control Message Protocol (ICMP) client library.
! *
! *************************************************************************/

!#define ICMP_ERROR                  -1

!#define _ICMP_BASE_ERROR                     26100
!#define ERROR_ICMP_NONE             0
!#define ERROR_ICMP_NETWORK          (_ICMP_BASE_ERROR+1)
!#define ERROR_ICMP_LICENSE          (_ICMP_BASE_ERROR+2)
!#define ERROR_ICMP_NOHANDLES        (_ICMP_BASE_ERROR+3)
!#define ERROR_ICMP_NOTOWNER         (_ICMP_BASE_ERROR+4)
!#define ERROR_ICMP_HANDLE           (_ICMP_BASE_ERROR+5)
!#define ERROR_ICMP_MEMORY           (_ICMP_BASE_ERROR+6)
!#define ERROR_ICMP_PARAMETER        (_ICMP_BASE_ERROR+7)
!#define ERROR_ICMP_ADDRESS          (_ICMP_BASE_ERROR+8)
!#define ERROR_ICMP_SOCKET           (_ICMP_BASE_ERROR+9)
!#define ERROR_ICMP_PACKETSIZE       (_ICMP_BASE_ERROR+10)
!#define ERROR_ICMP_PACKETDATA       (_ICMP_BASE_ERROR+11)
!#define ERROR_ICMP_READ             (_ICMP_BASE_ERROR+12)
!#define ERROR_ICMP_WRITE            (_ICMP_BASE_ERROR+13)
!#define ERROR_ICMP_RETRY            (_ICMP_BASE_ERROR+14)
!#define ERROR_ICMP_OVERFLOW         (_ICMP_BASE_ERROR+15)
!#define ERROR_ICMP_BLOCKED          (_ICMP_BASE_ERROR+16)
!#define ERROR_ICMP_CANCELED         (_ICMP_BASE_ERROR+17)
!#define ERROR_ICMP_TIMEOUT          (_ICMP_BASE_ERROR+18)
!#define ERROR_ICMP_NOASYNC          (_ICMP_BASE_ERROR+19)
!#define ERROR_ICMP_FAILED           (_ICMP_BASE_ERROR+20)
!#define ERROR_ICMP_UNREACHABLE      (_ICMP_BASE_ERROR+21)
!#define ERROR_ICMP_TTLEXPIRED       (_ICMP_BASE_ERROR+22)

ICMP_ERROR equate(-1)

_ICMP_BASE_ERROR            equate(26100)
ERROR_ICMP_NONE             equate(0)
ERROR_ICMP_NETWORK          equate(_ICMP_BASE_ERROR+1)
ERROR_ICMP_LICENSE          equate(_ICMP_BASE_ERROR+2)
ERROR_ICMP_NOHANDLES        equate(_ICMP_BASE_ERROR+3)
ERROR_ICMP_NOTOWNER         equate(_ICMP_BASE_ERROR+4)
ERROR_ICMP_HANDLE           equate(_ICMP_BASE_ERROR+5)
ERROR_ICMP_MEMORY           equate(_ICMP_BASE_ERROR+6)
ERROR_ICMP_PARAMETER        equate(_ICMP_BASE_ERROR+7)
ERROR_ICMP_ADDRESS          equate(_ICMP_BASE_ERROR+8)
ERROR_ICMP_SOCKET           equate(_ICMP_BASE_ERROR+9)
ERROR_ICMP_PACKETSIZE       equate(_ICMP_BASE_ERROR+10)
ERROR_ICMP_PACKETDATA       equate(_ICMP_BASE_ERROR+11)
ERROR_ICMP_READ             equate(_ICMP_BASE_ERROR+12)
ERROR_ICMP_WRITE            equate(_ICMP_BASE_ERROR+13)
ERROR_ICMP_RETRY            equate(_ICMP_BASE_ERROR+14)
ERROR_ICMP_OVERFLOW         equate(_ICMP_BASE_ERROR+15)
ERROR_ICMP_BLOCKED          equate(_ICMP_BASE_ERROR+16)
ERROR_ICMP_CANCELED         equate(_ICMP_BASE_ERROR+17)
ERROR_ICMP_TIMEOUT          equate(_ICMP_BASE_ERROR+18)
ERROR_ICMP_NOASYNC          equate(_ICMP_BASE_ERROR+19)
ERROR_ICMP_FAILED           equate(_ICMP_BASE_ERROR+20)
ERROR_ICMP_UNREACHABLE      equate(_ICMP_BASE_ERROR+21)
ERROR_ICMP_TTLEXPIRED       equate(_ICMP_BASE_ERROR+22)

!/*************************************************************************
! *
! * This section contains the error codes for the SocketTools
! * Multipurpose Internet Mail Extensions (MIME) library.
! *
! *************************************************************************/

!#define MIME_ERROR -1

!#define _MIME_BASE_ERROR            26300
!#define ERROR_MIME_NONE             0
!#define ERROR_MIME_LICENSE          (_MIME_BASE_ERROR+1)
!#define ERROR_MIME_NOHANDLES        (_MIME_BASE_ERROR+2)
!#define ERROR_MIME_NOTOWNER         (_MIME_BASE_ERROR+3)
!#define ERROR_MIME_HANDLE           (_MIME_BASE_ERROR+4)
!#define ERROR_MIME_MEMORY           (_MIME_BASE_ERROR+5)
!#define ERROR_MIME_PARAMETER        (_MIME_BASE_ERROR+6)
!#define ERROR_MIME_CREATE           (_MIME_BASE_ERROR+7)
!#define ERROR_MIME_HEADER           (_MIME_BASE_ERROR+8)
!#define ERROR_MIME_PART             (_MIME_BASE_ERROR+9)
!#define ERROR_MIME_PARSE            (_MIME_BASE_ERROR+10)
!#define ERROR_MIME_IMPORT           (_MIME_BASE_ERROR+11)
!#define ERROR_MIME_EXPORT           (_MIME_BASE_ERROR+12)
!#define ERROR_MIME_BOUNDARY         (_MIME_BASE_ERROR+13)
!#define ERROR_MIME_ATTACH           (_MIME_BASE_ERROR+14)
!#define ERROR_MIME_ENCODE           (_MIME_BASE_ERROR+15)
!#define ERROR_MIME_DECODE           (_MIME_BASE_ERROR+16)
!#define ERROR_MIME_BADFILE          (_MIME_BASE_ERROR+17)

MIME_ERROR equate(-1)

_MIME_BASE_ERROR            equate(26300)
ERROR_MIME_NONE             equate(0)
ERROR_MIME_LICENSE          equate(_MIME_BASE_ERROR+1)
ERROR_MIME_NOHANDLES        equate(_MIME_BASE_ERROR+2)
ERROR_MIME_NOTOWNER         equate(_MIME_BASE_ERROR+3)
ERROR_MIME_HANDLE           equate(_MIME_BASE_ERROR+4)
ERROR_MIME_MEMORY           equate(_MIME_BASE_ERROR+5)
ERROR_MIME_PARAMETER        equate(_MIME_BASE_ERROR+6)
ERROR_MIME_CREATE           equate(_MIME_BASE_ERROR+7)
ERROR_MIME_HEADER           equate(_MIME_BASE_ERROR+8)
ERROR_MIME_PART             equate(_MIME_BASE_ERROR+9)
ERROR_MIME_PARSE            equate(_MIME_BASE_ERROR+10)
ERROR_MIME_IMPORT           equate(_MIME_BASE_ERROR+11)
ERROR_MIME_EXPORT           equate(_MIME_BASE_ERROR+12)
ERROR_MIME_BOUNDARY         equate(_MIME_BASE_ERROR+13)
ERROR_MIME_ATTACH           equate(_MIME_BASE_ERROR+14)
ERROR_MIME_ENCODE           equate(_MIME_BASE_ERROR+15)
ERROR_MIME_DECODE           equate(_MIME_BASE_ERROR+16)
ERROR_MIME_BADFILE          equate(_MIME_BASE_ERROR+17)

!/*************************************************************************
! *
! * This section contains the error codes for the SocketTools
! * Network News Transfer Protocol (NNTP) client library.
! *
! *************************************************************************/

!#define NNTP_ERROR -1

!#define _NNTP_BASE_ERROR            26500
!#define ERROR_NNTP_NONE             0
!#define ERROR_NNTP_NETWORK          (_NNTP_BASE_ERROR+1)
!#define ERROR_NNTP_LICENSE          (_NNTP_BASE_ERROR+2)
!#define ERROR_NNTP_NOHANDLES        (_NNTP_BASE_ERROR+3)
!#define ERROR_NNTP_NOTOWNER         (_NNTP_BASE_ERROR+4)
!#define ERROR_NNTP_HANDLE           (_NNTP_BASE_ERROR+5)
!#define ERROR_NNTP_MEMORY           (_NNTP_BASE_ERROR+6)
!#define ERROR_NNTP_PARAMETER        (_NNTP_BASE_ERROR+7)
!#define ERROR_NNTP_HOSTNAME         (_NNTP_BASE_ERROR+8)
!#define ERROR_NNTP_SOCKET           (_NNTP_BASE_ERROR+9)
!#define ERROR_NNTP_CONNECT          (_NNTP_BASE_ERROR+10)
!#define ERROR_NNTP_TIMEOUT          (_NNTP_BASE_ERROR+11)
!#define ERROR_NNTP_SERVER           (_NNTP_BASE_ERROR+12)
!#define ERROR_NNTP_READ             (_NNTP_BASE_ERROR+13)
!#define ERROR_NNTP_WRITE            (_NNTP_BASE_ERROR+14)
!#define ERROR_NNTP_RETRY            (_NNTP_BASE_ERROR+15)
!#define ERROR_NNTP_OVERFLOW         (_NNTP_BASE_ERROR+16)
!#define ERROR_NNTP_CLOSED           (_NNTP_BASE_ERROR+17)
!#define ERROR_NNTP_BLOCKED          (_NNTP_BASE_ERROR+18)
!#define ERROR_NNTP_CANCELED         (_NNTP_BASE_ERROR+19)
!#define ERROR_NNTP_POSTING          (_NNTP_BASE_ERROR+20)
!#define ERROR_NNTP_NOSERVICE        (_NNTP_BASE_ERROR+21)
!#define ERROR_NNTP_BADGROUP         (_NNTP_BASE_ERROR+22)
!#define ERROR_NNTP_NOGROUP          (_NNTP_BASE_ERROR+23)
!#define ERROR_NNTP_EMPTYGROUP       (_NNTP_BASE_ERROR+24)
!#define ERROR_NNTP_NOARTICLE        (_NNTP_BASE_ERROR+25)
!#define ERROR_NNTP_LASTARTICLE      (_NNTP_BASE_ERROR+26)
!#define ERROR_NNTP_FIRSTARTICLE     (_NNTP_BASE_ERROR+27)
!#define ERROR_NNTP_BADARTICLE       (_NNTP_BASE_ERROR+28)
!#define ERROR_NNTP_NOTRANSFER       (_NNTP_BASE_ERROR+29)
!#define ERROR_NNTP_BADTRANSFER      (_NNTP_BASE_ERROR+30)
!#define ERROR_NNTP_REJECTED         (_NNTP_BASE_ERROR+31)
!#define ERROR_NNTP_NOPOSTING        (_NNTP_BASE_ERROR+32)
!#define ERROR_NNTP_BADPOST          (_NNTP_BASE_ERROR+33)
!#define ERROR_NNTP_COMMAND          (_NNTP_BASE_ERROR+34)
!#define ERROR_NNTP_RESTRICTED       (_NNTP_BASE_ERROR+35)
!#define ERROR_NNTP_FAULT            (_NNTP_BASE_ERROR+36)
!#define ERROR_NNTP_AUTHINFO         (_NNTP_BASE_ERROR+37)
!#define ERROR_NNTP_AUTHFAIL         (_NNTP_BASE_ERROR+38)
!#define ERROR_NNTP_AUTHTYPE         (_NNTP_BASE_ERROR+39)
!#define ERROR_NNTP_NOAUTH           (_NNTP_BASE_ERROR+40)
!#define ERROR_NNTP_UNEXPECTED       (_NNTP_BASE_ERROR+41)

NNTP_ERROR equate(-1)

_NNTP_BASE_ERROR            equate(26500)
ERROR_NNTP_NONE             equate(0)
ERROR_NNTP_NETWORK          equate(_NNTP_BASE_ERROR+1)
ERROR_NNTP_LICENSE          equate(_NNTP_BASE_ERROR+2)
ERROR_NNTP_NOHANDLES        equate(_NNTP_BASE_ERROR+3)
ERROR_NNTP_NOTOWNER         equate(_NNTP_BASE_ERROR+4)
ERROR_NNTP_HANDLE           equate(_NNTP_BASE_ERROR+5)
ERROR_NNTP_MEMORY           equate(_NNTP_BASE_ERROR+6)
ERROR_NNTP_PARAMETER        equate(_NNTP_BASE_ERROR+7)
ERROR_NNTP_HOSTNAME         equate(_NNTP_BASE_ERROR+8)
ERROR_NNTP_SOCKET           equate(_NNTP_BASE_ERROR+9)
ERROR_NNTP_CONNECT          equate(_NNTP_BASE_ERROR+10)
ERROR_NNTP_TIMEOUT          equate(_NNTP_BASE_ERROR+11)
ERROR_NNTP_SERVER           equate(_NNTP_BASE_ERROR+12)
ERROR_NNTP_READ             equate(_NNTP_BASE_ERROR+13)
ERROR_NNTP_WRITE            equate(_NNTP_BASE_ERROR+14)
ERROR_NNTP_RETRY            equate(_NNTP_BASE_ERROR+15)
ERROR_NNTP_OVERFLOW         equate(_NNTP_BASE_ERROR+16)
ERROR_NNTP_CLOSED           equate(_NNTP_BASE_ERROR+17)
ERROR_NNTP_BLOCKED          equate(_NNTP_BASE_ERROR+18)
ERROR_NNTP_CANCELED         equate(_NNTP_BASE_ERROR+19)
ERROR_NNTP_POSTING          equate(_NNTP_BASE_ERROR+20)
ERROR_NNTP_NOSERVICE        equate(_NNTP_BASE_ERROR+21)
ERROR_NNTP_BADGROUP         equate(_NNTP_BASE_ERROR+22)
ERROR_NNTP_NOGROUP          equate(_NNTP_BASE_ERROR+23)
ERROR_NNTP_EMPTYGROUP       equate(_NNTP_BASE_ERROR+24)
ERROR_NNTP_NOARTICLE        equate(_NNTP_BASE_ERROR+25)
ERROR_NNTP_LASTARTICLE      equate(_NNTP_BASE_ERROR+26)
ERROR_NNTP_FIRSTARTICLE     equate(_NNTP_BASE_ERROR+27)
ERROR_NNTP_BADARTICLE       equate(_NNTP_BASE_ERROR+28)
ERROR_NNTP_NOTRANSFER       equate(_NNTP_BASE_ERROR+29)
ERROR_NNTP_BADTRANSFER      equate(_NNTP_BASE_ERROR+30)
ERROR_NNTP_REJECTED         equate(_NNTP_BASE_ERROR+31)
ERROR_NNTP_NOPOSTING        equate(_NNTP_BASE_ERROR+32)
ERROR_NNTP_BADPOST          equate(_NNTP_BASE_ERROR+33)
ERROR_NNTP_COMMAND          equate(_NNTP_BASE_ERROR+34)
ERROR_NNTP_RESTRICTED       equate(_NNTP_BASE_ERROR+35)
ERROR_NNTP_FAULT            equate(_NNTP_BASE_ERROR+36)
ERROR_NNTP_AUTHINFO         equate(_NNTP_BASE_ERROR+37)
ERROR_NNTP_AUTHFAIL         equate(_NNTP_BASE_ERROR+38)
ERROR_NNTP_AUTHTYPE         equate(_NNTP_BASE_ERROR+39)
ERROR_NNTP_NOAUTH           equate(_NNTP_BASE_ERROR+40)
ERROR_NNTP_UNEXPECTED       equate(_NNTP_BASE_ERROR+41)

!/*************************************************************************
! *
! * This section contains the error codes for the SocketTools
! * Post Office Protocol v3 (POP3) client library.
! *
! *************************************************************************/

!#define POP_ERROR -1

!#define _POP_BASE_ERROR             26700
!#define ERROR_POP_NONE              0
!#define ERROR_POP_NETWORK           (_POP_BASE_ERROR+1)
!#define ERROR_POP_LICENSE           (_POP_BASE_ERROR+2)
!#define ERROR_POP_NOHANDLES         (_DNS_BASE_ERROR+3)
!#define ERROR_POP_NOTOWNER          (_DNS_BASE_ERROR+4)
!#define ERROR_POP_HANDLE            (_POP_BASE_ERROR+5)
!#define ERROR_POP_MEMORY            (_POP_BASE_ERROR+6)
!#define ERROR_POP_PARAMETER         (_POP_BASE_ERROR+7)
!#define ERROR_POP_HOSTNAME          (_POP_BASE_ERROR+8)
!#define ERROR_POP_SOCKET            (_POP_BASE_ERROR+9)
!#define ERROR_POP_CONNECT           (_POP_BASE_ERROR+10)
!#define ERROR_POP_TIMEOUT           (_POP_BASE_ERROR+11)
!#define ERROR_POP_SERVER            (_POP_BASE_ERROR+12)
!#define ERROR_POP_READ              (_POP_BASE_ERROR+13)
!#define ERROR_POP_WRITE             (_POP_BASE_ERROR+14)
!#define ERROR_POP_RETRY             (_POP_BASE_ERROR+15)
!#define ERROR_POP_OVERFLOW          (_POP_BASE_ERROR+16)
!#define ERROR_POP_CLOSED            (_POP_BASE_ERROR+17)
!#define ERROR_POP_BLOCKED           (_POP_BASE_ERROR+18)
!#define ERROR_POP_CANCELED          (_POP_BASE_ERROR+19)
!#define ERROR_POP_LOGIN             (_POP_BASE_ERROR+20)
!#define ERROR_POP_NOLOGIN           (_POP_BASE_ERROR+21)
!#define ERROR_POP_MESGID            (_POP_BASE_ERROR+22)

POP_ERROR equate(-1)

_POP_BASE_ERROR             equate(26700)
ERROR_POP_NONE              equate(0)
ERROR_POP_NETWORK           equate(_POP_BASE_ERROR+1)
ERROR_POP_LICENSE           equate(_POP_BASE_ERROR+2)
ERROR_POP_NOHANDLES         equate(_DNS_BASE_ERROR+3)
ERROR_POP_NOTOWNER          equate(_DNS_BASE_ERROR+4)
ERROR_POP_HANDLE            equate(_POP_BASE_ERROR+5)
ERROR_POP_MEMORY            equate(_POP_BASE_ERROR+6)
ERROR_POP_PARAMETER         equate(_POP_BASE_ERROR+7)
ERROR_POP_HOSTNAME          equate(_POP_BASE_ERROR+8)
ERROR_POP_SOCKET            equate(_POP_BASE_ERROR+9)
ERROR_POP_CONNECT           equate(_POP_BASE_ERROR+10)
ERROR_POP_TIMEOUT           equate(_POP_BASE_ERROR+11)
ERROR_POP_SERVER            equate(_POP_BASE_ERROR+12)
ERROR_POP_READ              equate(_POP_BASE_ERROR+13)
ERROR_POP_WRITE             equate(_POP_BASE_ERROR+14)
ERROR_POP_RETRY             equate(_POP_BASE_ERROR+15)
ERROR_POP_OVERFLOW          equate(_POP_BASE_ERROR+16)
ERROR_POP_CLOSED            equate(_POP_BASE_ERROR+17)
ERROR_POP_BLOCKED           equate(_POP_BASE_ERROR+18)
ERROR_POP_CANCELED          equate(_POP_BASE_ERROR+19)
ERROR_POP_LOGIN             equate(_POP_BASE_ERROR+20)
ERROR_POP_NOLOGIN           equate(_POP_BASE_ERROR+21)
ERROR_POP_MESGID            equate(_POP_BASE_ERROR+22)

!/*************************************************************************
! *
! * This section contains the error codes for the SocketTools
! * Remote Command client library.
! *
! *************************************************************************/

!#define RLIB_ERROR -1

!#define _RLIB_BASE_ERROR            26900
!#define ERROR_RLIB_NONE             0
!#define ERROR_RLIB_NETWORK          (_RLIB_BASE_ERROR+1)
!#define ERROR_RLIB_LICENSE          (_RLIB_BASE_ERROR+2)
!#define ERROR_RLIB_NOHANDLES        (_RLIB_BASE_ERROR+3)
!#define ERROR_RLIB_NOTOWNER         (_RLIB_BASE_ERROR+4)
!#define ERROR_RLIB_HANDLE           (_RLIB_BASE_ERROR+5)
!#define ERROR_RLIB_MEMORY           (_RLIB_BASE_ERROR+6)
!#define ERROR_RLIB_PARAMETER        (_RLIB_BASE_ERROR+7)
!#define ERROR_RLIB_HOSTNAME         (_RLIB_BASE_ERROR+8)
!#define ERROR_RLIB_SOCKET           (_RLIB_BASE_ERROR+9)
!#define ERROR_RLIB_CONNECT          (_RLIB_BASE_ERROR+10)
!#define ERROR_RLIB_ACCEPT           (_RLIB_BASE_ERROR+11)
!#define ERROR_RLIB_TIMEOUT          (_RLIB_BASE_ERROR+12)
!#define ERROR_RLIB_WRITE            (_RLIB_BASE_ERROR+13)
!#define ERROR_RLIB_READ             (_RLIB_BASE_ERROR+14)
!#define ERROR_RLIB_RETRY            (_RLIB_BASE_ERROR+15)
!#define ERROR_RLIB_OVERFLOW         (_RLIB_BASE_ERROR+16)
!#define ERROR_RLIB_CLOSED           (_RLIB_BASE_ERROR+17)
!#define ERROR_RLIB_BLOCKED          (_RLIB_BASE_ERROR+18)
!#define ERROR_RLIB_CANCELED         (_RLIB_BASE_ERROR+19)
!#define ERROR_RLIB_EXECUTE          (_RLIB_BASE_ERROR+20)

RLIB_ERROR equate(-1)

_RLIB_BASE_ERROR            equate(26900)
ERROR_RLIB_NONE             equate(0)
ERROR_RLIB_NETWORK          equate(_RLIB_BASE_ERROR+1)
ERROR_RLIB_LICENSE          equate(_RLIB_BASE_ERROR+2)
ERROR_RLIB_NOHANDLES        equate(_RLIB_BASE_ERROR+3)
ERROR_RLIB_NOTOWNER         equate(_RLIB_BASE_ERROR+4)
ERROR_RLIB_HANDLE           equate(_RLIB_BASE_ERROR+5)
ERROR_RLIB_MEMORY           equate(_RLIB_BASE_ERROR+6)
ERROR_RLIB_PARAMETER        equate(_RLIB_BASE_ERROR+7)
ERROR_RLIB_HOSTNAME         equate(_RLIB_BASE_ERROR+8)
ERROR_RLIB_SOCKET           equate(_RLIB_BASE_ERROR+9)
ERROR_RLIB_CONNECT          equate(_RLIB_BASE_ERROR+10)
ERROR_RLIB_ACCEPT           equate(_RLIB_BASE_ERROR+11)
ERROR_RLIB_TIMEOUT          equate(_RLIB_BASE_ERROR+12)
ERROR_RLIB_WRITE            equate(_RLIB_BASE_ERROR+13)
ERROR_RLIB_READ             equate(_RLIB_BASE_ERROR+14)
ERROR_RLIB_RETRY            equate(_RLIB_BASE_ERROR+15)
ERROR_RLIB_OVERFLOW         equate(_RLIB_BASE_ERROR+16)
ERROR_RLIB_CLOSED           equate(_RLIB_BASE_ERROR+17)
ERROR_RLIB_BLOCKED          equate(_RLIB_BASE_ERROR+18)
ERROR_RLIB_CANCELED         equate(_RLIB_BASE_ERROR+19)
ERROR_RLIB_EXECUTE          equate(_RLIB_BASE_ERROR+20)

!/*************************************************************************
! *
! * This section contains the error codes for the SocketTools
! * Simple Mail Transfer Protocol (SMTP) client library.
! *
! *************************************************************************/

!#define SMTP_ERROR -1

!#define _SMTP_BASE_ERROR            27100
!#define ERROR_SMTP_NONE             0
!#define ERROR_SMTP_NETWORK          (_SMTP_BASE_ERROR+1)
!#define ERROR_SMTP_LICENSE          (_SMTP_BASE_ERROR+2)
!#define ERROR_SMTP_NOHANDLES        (_SMTP_BASE_ERROR+3)
!#define ERROR_SMTP_NOTOWNER         (_SMTP_BASE_ERROR+4)
!#define ERROR_SMTP_HANDLE           (_SMTP_BASE_ERROR+5)
!#define ERROR_SMTP_MEMORY           (_SMTP_BASE_ERROR+6)
!#define ERROR_SMTP_PARAMETER        (_SMTP_BASE_ERROR+7)
!#define ERROR_SMTP_HOSTNAME         (_SMTP_BASE_ERROR+8)
!#define ERROR_SMTP_SOCKET           (_SMTP_BASE_ERROR+9)
!#define ERROR_SMTP_CONNECT          (_SMTP_BASE_ERROR+10)
!#define ERROR_SMTP_TIMEOUT          (_SMTP_BASE_ERROR+11)
!#define ERROR_SMTP_SERVER           (_SMTP_BASE_ERROR+12)
!#define ERROR_SMTP_READ             (_SMTP_BASE_ERROR+13)
!#define ERROR_SMTP_WRITE            (_SMTP_BASE_ERROR+14)
!#define ERROR_SMTP_RETRY            (_SMTP_BASE_ERROR+15)
!#define ERROR_SMTP_OVERFLOW         (_SMTP_BASE_ERROR+16)
!#define ERROR_SMTP_CLOSED           (_SMTP_BASE_ERROR+17)
!#define ERROR_SMTP_BLOCKED          (_SMTP_BASE_ERROR+18)
!#define ERROR_SMTP_CANCELED         (_SMTP_BASE_ERROR+19)
!#define ERROR_SMTP_ADDRESS          (_SMTP_BASE_ERROR+20)
!#define ERROR_SMTP_RECPT            (_SMTP_BASE_ERROR+21)
!#define ERROR_SMTP_DATA             (_SMTP_BASE_ERROR+22)
!#define ERROR_SMTP_NODATA           (_SMTP_BASE_ERROR+23)

SMTP_ERROR equate(-1)

_SMTP_BASE_ERROR            equate(27100)
ERROR_SMTP_NONE             equate(0)
ERROR_SMTP_NETWORK          equate(_SMTP_BASE_ERROR+1)
ERROR_SMTP_LICENSE          equate(_SMTP_BASE_ERROR+2)
ERROR_SMTP_NOHANDLES        equate(_SMTP_BASE_ERROR+3)
ERROR_SMTP_NOTOWNER         equate(_SMTP_BASE_ERROR+4)
ERROR_SMTP_HANDLE           equate(_SMTP_BASE_ERROR+5)
ERROR_SMTP_MEMORY           equate(_SMTP_BASE_ERROR+6)
ERROR_SMTP_PARAMETER        equate(_SMTP_BASE_ERROR+7)
ERROR_SMTP_HOSTNAME         equate(_SMTP_BASE_ERROR+8)
ERROR_SMTP_SOCKET           equate(_SMTP_BASE_ERROR+9)
ERROR_SMTP_CONNECT          equate(_SMTP_BASE_ERROR+10)
ERROR_SMTP_TIMEOUT          equate(_SMTP_BASE_ERROR+11)
ERROR_SMTP_SERVER           equate(_SMTP_BASE_ERROR+12)
ERROR_SMTP_READ             equate(_SMTP_BASE_ERROR+13)
ERROR_SMTP_WRITE            equate(_SMTP_BASE_ERROR+14)
ERROR_SMTP_RETRY            equate(_SMTP_BASE_ERROR+15)
ERROR_SMTP_OVERFLOW         equate(_SMTP_BASE_ERROR+16)
ERROR_SMTP_CLOSED           equate(_SMTP_BASE_ERROR+17)
ERROR_SMTP_BLOCKED          equate(_SMTP_BASE_ERROR+18)
ERROR_SMTP_CANCELED         equate(_SMTP_BASE_ERROR+19)
ERROR_SMTP_ADDRESS          equate(_SMTP_BASE_ERROR+20)
ERROR_SMTP_RECPT            equate(_SMTP_BASE_ERROR+21)
ERROR_SMTP_DATA             equate(_SMTP_BASE_ERROR+22)
ERROR_SMTP_NODATA           equate(_SMTP_BASE_ERROR+23)
!/*************************************************************************
! *
! * This section contains the error codes for the SocketTools
! * Windows Sockets (SocketWrench) library.
! *
! *************************************************************************

!#define INVALID_SOCKET -1
!
!#define _INET_BASE_ERROR           28000
!#define ERROR_INET_NONE            0
!#define ERROR_INET_NETWORK         (_INET_BASE_ERROR+1)
!#define ERROR_INET_LICENSE         (_INET_BASE_ERROR+2)
!#define ERROR_INET_NOHANDLES       (_INET_BASE_ERROR+3)
!#define ERROR_INET_NOTOWNER        (_INET_BASE_ERROR+4)
!#define ERROR_INET_HANDLE          (_INET_BASE_ERROR+5)
!#define ERROR_INET_MEMORY          (_INET_BASE_ERROR+6)
!#define ERROR_INET_PARAMETER       (_INET_BASE_ERROR+7)
!#define ERROR_INET_PROTOCOL        (_INET_BASE_ERROR+8)
!#define ERROR_INET_EVENTID         (_INET_BASE_ERROR+9)
!#define ERROR_INET_LOCALHOST       (_INET_BASE_ERROR+10)
!#define ERROR_INET_HOSTNAME        (_INET_BASE_ERROR+11)
!#define ERROR_INET_HOSTADDRESS     (_INET_BASE_ERROR+12)
!#define ERROR_INET_OPTION          (_INET_BASE_ERROR+13)
!#define ERROR_INET_SOCKET          (_INET_BASE_ERROR+14)
!#define ERROR_INET_BIND            (_INET_BASE_ERROR+15)
!#define ERROR_INET_CONNECT         (_INET_BASE_ERROR+16)
!#define ERROR_INET_ACCEPT          (_INET_BASE_ERROR+17)
!#define ERROR_INET_LISTEN          (_INET_BASE_ERROR+18)
!#define ERROR_INET_READ            (_INET_BASE_ERROR+19)
!#define ERROR_INET_WRITE           (_INET_BASE_ERROR+20)
!#define ERROR_INET_TIMEOUT         (_INET_BASE_ERROR+21)
!#define ERROR_INET_BLOCKED         (_INET_BASE_ERROR+22)
!#define ERROR_INET_CANCELED        (_INET_BASE_ERROR+23)

INVALID_SOCKET                      EQUATE(-1)

_INET_BASE_ERROR                    EQUATE(28000)
ERROR_INET_NONE                     EQUATE(0)
ERROR_INET_NETWORK                  EQUATE(_INET_BASE_ERROR+1)
ERROR_INET_LICENSE                  EQUATE(_INET_BASE_ERROR+2)
ERROR_INET_NOHANDLES                EQUATE(_INET_BASE_ERROR+3)
ERROR_INET_NOTOWNER                 EQUATE(_INET_BASE_ERROR+4)
ERROR_INET_HANDLE                   EQUATE(_INET_BASE_ERROR+5)
ERROR_INET_MEMORY                   EQUATE(_INET_BASE_ERROR+6)
ERROR_INET_PARAMETER                EQUATE(_INET_BASE_ERROR+7)
ERROR_INET_PROTOCOL                 EQUATE(_INET_BASE_ERROR+8)
ERROR_INET_EVENTID                  EQUATE(_INET_BASE_ERROR+9)
ERROR_INET_LOCALHOST                EQUATE(_INET_BASE_ERROR+10)
ERROR_INET_HOSTNAME                 EQUATE(_INET_BASE_ERROR+11)
ERROR_INET_HOSTADDRESS              EQUATE(_INET_BASE_ERROR+12)
ERROR_INET_OPTION                   EQUATE(_INET_BASE_ERROR+13)
ERROR_INET_SOCKET                   EQUATE(_INET_BASE_ERROR+14)
ERROR_INET_BIND                     EQUATE(_INET_BASE_ERROR+15)
ERROR_INET_CONNECT                  EQUATE(_INET_BASE_ERROR+16)
ERROR_INET_ACCEPT                   EQUATE(_INET_BASE_ERROR+17)
ERROR_INET_LISTEN                   EQUATE(_INET_BASE_ERROR+18)
ERROR_INET_READ                     EQUATE(_INET_BASE_ERROR+19)
ERROR_INET_WRITE                    EQUATE(_INET_BASE_ERROR+20)
ERROR_INET_TIMEOUT                  EQUATE(_INET_BASE_ERROR+21)
ERROR_INET_BLOCKED                  EQUATE(_INET_BASE_ERROR+22)
ERROR_INET_CANCELED                 EQUATE(_INET_BASE_ERROR+23)

!/*************************************************************************
! *
! * This section contains the error codes for the SocketTools
! * Telnet client library.
! *
! *************************************************************************/

!#define TELNET_ERROR -1

!#define _TELNET_BASE_ERROR          27500
!#define ERROR_TELNET_NONE           0
!#define ERROR_TELNET_NETWORK        (_TELNET_BASE_ERROR+1)
!#define ERROR_TELNET_LICENSE        (_TELNET_BASE_ERROR+2)
!#define ERROR_TELNET_NOHANDLES      (_TELNET_BASE_ERROR+3)
!#define ERROR_TELNET_NOTOWNER       (_TELNET_BASE_ERROR+4)
!#define ERROR_TELNET_HANDLE         (_TELNET_BASE_ERROR+5)
!#define ERROR_TELNET_MEMORY         (_TELNET_BASE_ERROR+6)
!#define ERROR_TELNET_PARAMETER      (_TELNET_BASE_ERROR+7)
!#define ERROR_TELNET_HOSTNAME       (_TELNET_BASE_ERROR+8)
!#define ERROR_TELNET_SOCKET         (_TELNET_BASE_ERROR+9)
!#define ERROR_TELNET_CONNECT        (_TELNET_BASE_ERROR+10)
!#define ERROR_TELNET_TIMEOUT        (_TELNET_BASE_ERROR+11)
!#define ERROR_TELNET_SERVER         (_TELNET_BASE_ERROR+12)
!#define ERROR_TELNET_READ           (_TELNET_BASE_ERROR+13)
!#define ERROR_TELNET_WRITE          (_TELNET_BASE_ERROR+14)
!#define ERROR_TELNET_RETRY          (_TELNET_BASE_ERROR+15)
!#define ERROR_TELNET_OVERFLOW       (_TELNET_BASE_ERROR+16)
!#define ERROR_TELNET_CLOSED         (_TELNET_BASE_ERROR+17)
!#define ERROR_TELNET_BLOCKED        (_TELNET_BASE_ERROR+18)
!#define ERROR_TELNET_CANCELED       (_TELNET_BASE_ERROR+19)
!#define ERROR_TELNET_RESYNC         (_TELNET_BASE_ERROR+20)
!#define ERROR_TELNET_OPTION         (_TELNET_BASE_ERROR+21)

TELNET_ERROR equate(-1)

_TELNET_BASE_ERROR          equate(27500)
ERROR_TELNET_NONE           equate(0)
ERROR_TELNET_NETWORK        equate(_TELNET_BASE_ERROR+1)
ERROR_TELNET_LICENSE        equate(_TELNET_BASE_ERROR+2)
ERROR_TELNET_NOHANDLES      equate(_TELNET_BASE_ERROR+3)
ERROR_TELNET_NOTOWNER       equate(_TELNET_BASE_ERROR+4)
ERROR_TELNET_HANDLE         equate(_TELNET_BASE_ERROR+5)
ERROR_TELNET_MEMORY         equate(_TELNET_BASE_ERROR+6)
ERROR_TELNET_PARAMETER      equate(_TELNET_BASE_ERROR+7)
ERROR_TELNET_HOSTNAME       equate(_TELNET_BASE_ERROR+8)
ERROR_TELNET_SOCKET         equate(_TELNET_BASE_ERROR+9)
ERROR_TELNET_CONNECT        equate(_TELNET_BASE_ERROR+10)
ERROR_TELNET_TIMEOUT        equate(_TELNET_BASE_ERROR+11)
ERROR_TELNET_SERVER         equate(_TELNET_BASE_ERROR+12)
ERROR_TELNET_READ           equate(_TELNET_BASE_ERROR+13)
ERROR_TELNET_WRITE          equate(_TELNET_BASE_ERROR+14)
ERROR_TELNET_RETRY          equate(_TELNET_BASE_ERROR+15)
ERROR_TELNET_OVERFLOW       equate(_TELNET_BASE_ERROR+16)
ERROR_TELNET_CLOSED         equate(_TELNET_BASE_ERROR+17)
ERROR_TELNET_BLOCKED        equate(_TELNET_BASE_ERROR+18)
ERROR_TELNET_CANCELED       equate(_TELNET_BASE_ERROR+19)
ERROR_TELNET_RESYNC         equate(_TELNET_BASE_ERROR+20)
ERROR_TELNET_OPTION         equate(_TELNET_BASE_ERROR+21)

!/*************************************************************************
! *
! * This section contains the error codes for the SocketTools
! * Whois client library.
! *
! *************************************************************************/

!#define WHOIS_ERROR -1

!#define _WHOIS_BASE_ERROR           27900
!#define ERROR_WHOIS_NONE            0
!#define ERROR_WHOIS_NETWORK         (_WHOIS_BASE_ERROR+1)
!#define ERROR_WHOIS_LICENSE         (_WHOIS_BASE_ERROR+2)
!#define ERROR_WHOIS_NOHANDLES       (_WHOIS_BASE_ERROR+3)
!#define ERROR_WHOIS_NOTOWNER        (_WHOIS_BASE_ERROR+4)
!#define ERROR_WHOIS_HANDLE          (_WHOIS_BASE_ERROR+5)
!#define ERROR_WHOIS_MEMORY          (_WHOIS_BASE_ERROR+6)
!#define ERROR_WHOIS_PARAMETER       (_WHOIS_BASE_ERROR+7)
!#define ERROR_WHOIS_HOSTNAME        (_WHOIS_BASE_ERROR+8)
!#define ERROR_WHOIS_SOCKET          (_WHOIS_BASE_ERROR+9)
!#define ERROR_WHOIS_CONNECT         (_WHOIS_BASE_ERROR+10)
!#define ERROR_WHOIS_TIMEOUT         (_WHOIS_BASE_ERROR+11)
!#define ERROR_WHOIS_READ            (_WHOIS_BASE_ERROR+12)
!#define ERROR_WHOIS_WRITE           (_WHOIS_BASE_ERROR+13)
!#define ERROR_WHOIS_RETRY           (_WHOIS_BASE_ERROR+14)
!#define ERROR_WHOIS_OVERFLOW        (_WHOIS_BASE_ERROR+15)
!#define ERROR_WHOIS_CLOSED          (_WHOIS_BASE_ERROR+16)
!#define ERROR_WHOIS_BLOCKED         (_WHOIS_BASE_ERROR+17)
!#define ERROR_WHOIS_CANCELED        (_WHOIS_BASE_ERROR+18)
!#define ERROR_WHOIS_SEARCH          (_WHOIS_BASE_ERROR+19)

WHOIS_ERROR equate(-1)

_WHOIS_BASE_ERROR           equate(27900)
ERROR_WHOIS_NONE            equate(0)
ERROR_WHOIS_NETWORK         equate(_WHOIS_BASE_ERROR+1)
ERROR_WHOIS_LICENSE         equate(_WHOIS_BASE_ERROR+2)
ERROR_WHOIS_NOHANDLES       equate(_WHOIS_BASE_ERROR+3)
ERROR_WHOIS_NOTOWNER        equate(_WHOIS_BASE_ERROR+4)
ERROR_WHOIS_HANDLE          equate(_WHOIS_BASE_ERROR+5)
ERROR_WHOIS_MEMORY          equate(_WHOIS_BASE_ERROR+6)
ERROR_WHOIS_PARAMETER       equate(_WHOIS_BASE_ERROR+7)
ERROR_WHOIS_HOSTNAME        equate(_WHOIS_BASE_ERROR+8)
ERROR_WHOIS_SOCKET          equate(_WHOIS_BASE_ERROR+9)
ERROR_WHOIS_CONNECT         equate(_WHOIS_BASE_ERROR+10)
ERROR_WHOIS_TIMEOUT         equate(_WHOIS_BASE_ERROR+11)
ERROR_WHOIS_READ            equate(_WHOIS_BASE_ERROR+12)
ERROR_WHOIS_WRITE           equate(_WHOIS_BASE_ERROR+13)
ERROR_WHOIS_RETRY           equate(_WHOIS_BASE_ERROR+14)
ERROR_WHOIS_OVERFLOW        equate(_WHOIS_BASE_ERROR+15)
ERROR_WHOIS_CLOSED          equate(_WHOIS_BASE_ERROR+16)
ERROR_WHOIS_BLOCKED         equate(_WHOIS_BASE_ERROR+17)
ERROR_WHOIS_CANCELED        equate(_WHOIS_BASE_ERROR+18)
ERROR_WHOIS_SEARCH          equate(_WHOIS_BASE_ERROR+19)

!#ifdef __cplusplus
!}
!#endif
!#endif /* _CSTOOLS_CSERROR_H */